<template >
  <div>
    <div id="input-div">
      <b-form-input
        v-model="text"
        placeholder="Enter your new keyword"
      ></b-form-input>
      <b-button @click="updateKeyword()" variant="success">+</b-button>
    </div>
    <div class="container">
      <div class="row" style="margin-top: 5%">
        <div v-for="(value, idx) in items" :key="idx" class="col-lg-4 col-md-6 col-sm-6 col-xs-6" style="text-align: center">
          <b-card tag="article" style="min-width: 20rem" class="mb-2">
            <b-card-text style="text-align: center">
              {{ value }}
            </b-card-text>
            <b-button variant="danger" @click="deleteKeyword(value)">Delete keyword</b-button>
          </b-card>
        </div>
    </div>
    </div>
  </div>
</template>

<script>
import Vue from 'vue'
import { mapGetters, mapMutations } from 'vuex'
import { Notyf } from 'notyf';
import 'notyf/notyf.min.css';

export default {
  components: {},
  data() {
    return {
      text: '',
      items: [],
      selectedUser: {},
      currentKeywords: [],
      currentKeywordString: '',
    }
  },
  methods: {
    onPaginationData(paginationData) {
      this.$refs.pagination.setPaginationData(paginationData)
    },
    onChangePage(page) {
      this.$refs.vuetable.changePage(page)
    },
    rowSelected(items) {
      this.bootstrapTable.selected = items
      this.selectedUser = items[0]
    },
    async dataProvider(ctx) {
      //   console.log("lol", this.currentUser.id)
      return await Vue.prototype.$http
        .get(`http://localhost:3000/api/users/${this.currentUser.id}`)
        .then((result) => result.data)
        .then((data) => {
          this.currentPage = data.current_page
          this.perPage = data.per_page
          this.totalRows = data.total
          this.currentKeywords = data.keywords
          this.currentKeywordString = this.currentKeywords.toString()
          this.currentKeywordString = this.currentKeywordString.replaceAll(
            ',',
            ';'
          )
          // console.log(';', this.currentKeywordString)
          this.items = data.keywords
          // console.log('apres filter', this.items)
          return this.items
        })
        .catch((_error) => {
          return []
        })
    },
    apiParamsConverter(params) {
      let apiParams = {}
      if (params.perPage !== 0) {
        apiParams.per_page = params.perPage
      }
      if (params.currentPage >= 1) {
        apiParams.page = params.currentPage
      }
      if (params.sortBy.length > 0) {
        apiParams.sort = `${params.sortBy}|${params.sortDesc ? 'desc' : 'asc'}`
      }
      if (params.filter.length > 0) {
        // Optional
      }
      return apiParams
    },
    hideModal(refname) {
      this.$refs[refname].hide()
      this.dataProvider()
    },
    addNotification(type, title, message) {
      this.$notify(type, title, message, { duration: 3000, permanent: false })
    },
    async updateKeyword() {
      //   this.hideModal('modalright')
      this.currentKeywordString = ';' + this.currentKeywordString + ';'
      if (this.currentKeywordString.includes(';' + this.text + ';')) {
        // console.log('exists')
        const notyf = new Notyf();
        notyf.error('Keyword already exists');
      } else {
        // console.log(this.currentKeywords)
        await Vue.prototype.$http
          .patch(`http://localhost:3000/api/users/${this.currentUser.id}`, {
            keywords: [this.currentKeywordString + ';' + this.text],
          })
          .then(() => {
            this.dataProvider()
            this.text = ''
          })
          .catch((err) => {
            // console.log(err)
          })
      }
    },
    async deleteKeyword(value) {
        this.currentKeywordString = ';' + this.currentKeywordString + ';'
        this.currentKeywordString = this.currentKeywordString.replace(value + ';', '')
        // console.log("new", this.currentKeywordString)
        await Vue.prototype.$http
          .patch(`http://localhost:3000/api/users/${this.currentUser.id}`, {
            keywords: [this.currentKeywordString],
          })
          .then(() => {
            this.dataProvider()
          })
          .catch((err) => {
            // console.log(err)
          })
    },
    addKeyword() {
      Vue.prototype.$http
        .post('http://localhost:3000/api/cryptos/', this.newCrypto)
        .then((res) => {
          // console.log(res)
        })
        // .catch((err) => {console.log(err)})
    },
  },
  computed: {
    ...mapGetters({
      currentUser: 'currentUser',
    }),
  },
  mounted() {
    this.dataProvider()
  },
}
</script>

<style scoped>
#input-div {
  display: flex;
  align-content: center;
  flex-direction: row;
}

#input-div button {
  margin-left: 10px;
}

#key-parent {
  margin-top: 5%;
  display: flex;
  flex-direction: row;
  justify-content: space-around;
  /* flex-wrap: wrap; */
}

#key-div {
  display: flex;
  /* align-content: space-around; */
  /* margin-top: 10%;
    margin-left: 10px; */
}
</style>
